# Markdown web browser
A web browser that let's you browse gemini capsules that use gemtext as a superior standard to html.

# Requirements
- gemget

# Installing
## Build from source:
- Clone the repo
```cargo run -r```

# Help
Type h in the program to see this text:
```
Source code: https://git.javalsai.dynv6.net/deadvey/markdown-webbrowser
q: quit
d: debug info
h: help
r: reload
s: view source code of page
i: visit root index of this host eg: root index of gemini://deadvey.com/blog/4.md is just gemini://deadvey.com
b: go back in history
f: go forward in history
ox: print the hyprlink of reference x eg: o5 or o24
[url]: follow the inputed url
```

# Example:
![screenshot](/images/screenshot.png)

# TO DO
- Make pages scrollable
- Bookmarks
- Properly comment it because I can't lie I can't even follow it.
- Make it memory safe, it crashes if the input is unexpected.
- Use treesitter instead of Regex, because, reasons.
    - "wtf deadvey" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet) 
    - "Don't use Regex to parse **ANYTHING**" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "use treesitter" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "yeah, definitley use treesitter" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "use treesitter" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "or glow" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "I found another markdown to terminal converter" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "ban [for using regex]"  - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
    - "use treesitter" - [error](https://git.javalsai.dynv6.net/ErrorNoInternet)
- Get a catchier name, 'markdown web browser' sounds kind of lame.

![error yapping](/images/error_yapping.gif)
